/* SD Card Test Xmega    */
/* Udo Matthe 2009/09/27 */

#include <avr/io.h>
#include <util/delay.h>
#include "stdio.h"
#include "usart.h"
#include "spi.h"
#include "mmc.h"
#include "ff.h"
#include "fileapp.h"

static	FATFS fs;            // Work area (file system object) for logical drive

int main(void)
{
    uint16_t len;
    FIL handle;
 	FRESULT res;         // FatFs function common result code
	char l[]="Hallo, diese ist ein Test\n\r";

	char filename[]="/ff.c";
	char outfilename[]="/langer.testname.txt";

  uart_init();
  spi_init();
  uart_puts_P("Udos XMega SD Test\n\r");

  res=f_mount(0, &fs);
  if(res!=FR_OK)
  {
    uart_puts_P("Mount Error");
	uart_puthexbyte(res);
	uart_eol();
  }
  else
  {
    uart_puts_P("Mount OK\n\r");
    delayms(2000);

    // Read File and Display on USART
    uart_puts_P("Read ");
    uart_puts(filename);
    uart_eol();
	show_file(filename);
    uart_puts_P("--- Read-File-Test Done ---\n\r");


    uart_puts_P("Write ");
    uart_puts(outfilename);
    uart_eol();
    res = f_open(&handle, outfilename, FA_CREATE_ALWAYS|FA_WRITE);
    if(res!=FR_OK)
    {
            // Error Handling
		    uart_puts_P("Error: Unable to open: ");
 	        uart_puthexbyte(res);
	        uart_eol();
    }
	for(uint8_t i=0;i<255;i++)
	{
	   
	   res=f_write(&handle,l,sizeof(l),&len);
       if(res!=FR_OK)
       {
            // Error Handling
		    uart_puts_P("Error: Unable to write: ");
 	        uart_puthexbyte(res);
	        uart_eol();
			break;
       }
	}
	f_close(&handle);
    if(res!=FR_OK)
    {
            // Error Handling
		    uart_puts_P("Error: Unable to close: ");
 	        uart_puthexbyte(res);
	        uart_eol();
    }

    uart_puts_P("--- Write-File-Test Done ---\n\r");

    // Read Directory and Display on USART
    show_dir();
    uart_puts_P("--- Directory-Test Done ---\n\r");

    uart_puts_P("--- All-SDcard-Tests Done ---\n\r");
  }

  while (1)
  {
  }

  return 0;
}


