#include <avr/io.h>
#include "stdio.h"

#include "ff.h"
#include "fileapp.h"
#include "usart.h"

static  FILINFO finfo;
#define LINELEN 160
static char fsline[LINELEN];

FRESULT show_dir(void)
{
	DIR dir;
	uint32_t  p1;
        FRESULT res;
	uint16_t s1, s2;
	char *fn;
#if _USE_LFN  // defined in ff.h
        char Lfname[_MAX_LFN];
#endif

		res = f_opendir(&dir, "/");
		if (res==FR_OK)
		{
		  p1 = s1 = s2 = 0;

#if _USE_LFN  // defined in ff.h
		  finfo.lfname = Lfname;
		  finfo.lfsize = sizeof(Lfname);
#endif

		  for(;;) 
		  {
			res = f_readdir(&dir, &finfo);
			if ((res != FR_OK) || !finfo.fname[0]) break;
			if (finfo.fattrib & AM_DIR) 
			{
				s2++;
			} 
			else 
			{
				s1++; p1 += finfo.fsize;
			}
#if _USE_LFN  // defined in ff.h
			if(finfo.lfname[0]==0)
			{
				fn=finfo.fname;
			}
			else
			{
				fn=finfo.lfname;
			}
#else
			fn=finfo.fname;
#endif
/*
			sprintf(fsline,"%c%c%c%c%c %u/%02u/%02u %02u:%02u %9lu  %s",
					(finfo.fattrib & AM_DIR) ? 'D' : '-',
					(finfo.fattrib & AM_RDO) ? 'R' : '-',
					(finfo.fattrib & AM_HID) ? 'H' : '-',
					(finfo.fattrib & AM_SYS) ? 'S' : '-',
					(finfo.fattrib & AM_ARC) ? 'A' : '-',
					(finfo.fdate >> 9) + 1980, (finfo.fdate >> 5) & 15, finfo.fdate & 31,
					(finfo.ftime >> 11), (finfo.ftime >> 5) & 63, 
					finfo.fsize, 
					fn
			       );
			  uart_puts(fsline);
*/
              uart_puts(fn);
			  uart_eol();
			
		  }
//		  sprintf(fsline,"%4u File(s),%10lu bytes total\r\n%4u Dir(s)", s1, p1, s2);
//		  uart_puts(fsline);
//		  uart_eol();
		}

		return res;

}
char* readline ( char* buff, uint8_t len, FIL* fil )
{
	uint8_t i = 0;
	char *p = buff;
	uint16_t rc;


	while (i < len - 1) {                   /* Read bytes until buffer gets filled */
		f_read(fil, p, 1, &rc);
		if (rc != 1) break;                     /* Break when no data to read */
		if (*p == '\r') continue;       /* Strip '\r' */
		i++;
		if (*p == '\n') break;        /* Break when reached end of line */
		*p++;
	}
	*p = 0;
	return i ? buff : 0;                    /* When no data read (eof or error), return with error. */
}



FRESULT show_file(char *filename)
{
        FIL handle;
        FRESULT res;

        res = f_open(&handle, filename,  FA_READ);
        if(res!=FR_OK)
        {
                // Error Handling
		uart_puts_P("Error: Unable to open: ");
 	    uart_puthexbyte(res);
	    uart_eol();
       }
        else
        {
		   // Aus dem File lesen
           while(readline(fsline,LINELEN,&handle))
           {
					uart_puts(fsline);
					uart_eol();
           } 

        }
        f_close(&handle);
	return res;
}
