#ifndef _MMC_H_
#define _MMC_H_

#include <avr/io.h>
#include <stdint.h>

#include "config.h"

#ifndef _MMC_Write_
#define _MMC_Write_        PORTE.OUT	// CS Port 
#warning "_MMC_Write_ not defined using Default PORTE"
#endif
#ifndef _MMC_DDR_
#define _MMC_DDR_  PORTE.DIR
#warning "_MMC_DDR_ not defined using Default PORTE"
#endif
#ifndef _MMC_Chip_Select_
#define _MMC_Chip_Select_  4	// CS Pin
#warning "_MMC_Chip_Select_ not defined using Default PE4"
#endif

void delayms(uint32_t ms);

uint8_t mmc_init(void);

uint8_t mmc_read_sector (uint32_t ,uint8_t *);

uint8_t mmc_write_sector (uint32_t ,const uint8_t *);

uint8_t mmc_write_command (uint8_t cmd, uint32_t arg);

uint8_t mmc_wait_ready(void);

uint8_t mmc_get_CardType(void);

void mmc_dump_buffer(uint8_t * ,uint16_t);

#define MMC_Disable() _MMC_Write_|=  _BV(_MMC_Chip_Select_)
#define MMC_Enable()  _MMC_Write_&= ~_BV(_MMC_Chip_Select_)

// Dummy Calls Xmega-Evalboard can not switch SD-Slot on/off
#define MMC_On() 
#define MMC_Off()


#endif //_MMC_H_
